function DebuffFilter_Initialize()
	if (DebuffFilter_Config == nil) then
		DebuffFilter_Config = {};
	end

	if (DebuffFilter_Config[DebuffFilter_Player] == nil) then
		DebuffFilter_Config[DebuffFilter_Player] = {};
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["debuffs"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["debuffs"] = "yes";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["buffs"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["buffs"] = "no";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["scale"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["scale"] = 1;
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["debuff_orientation"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["debuff_orientation"] = "leftright";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["buff_orientation"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["buff_orientation"] = "leftright";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] = "bottom";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["target"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["target"] = "target";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["count"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["count"] = "no";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["tooltips"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["tooltips"] = "yes";
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["debuff_list"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["debuff_list"] = {
			["Sunder Armor"] = 1,
			["Faerie Fire"] = 1,
			["Curse of Recklessness"] = 1,
			["Thunder Clap"] = 1,
			["Expose Armor"] = 1,
		}
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["buff_list"] == nil) then
		DebuffFilter_Config[DebuffFilter_Player]["buff_list"] = {
			["Battle Shout"] = 1,
			["Adrenaline Rush"] = 1,
			["Blade Flurry"] = 1,
			["Holy Strength"] = 1,
		}
	end

	SlashCmdList["DFILTER"] = DebuffFilter_command;
	SLASH_DFILTER1 = "/dfilter";

	if (DebuffFilter_Config[DebuffFilter_Player]["debuffs"] == "no") then
		DebuffFilter_DebuffFrame:Hide();
		DebuffFilter_UnregisterEvents("debuffs");
	end

	if (DebuffFilter_Config[DebuffFilter_Player]["buffs"] == "no") then
		DebuffFilter_BuffFrame:Hide();
		DebuffFilter_UnregisterEvents("buffs");
	end

	DebuffFilter_FrameOrientation(DebuffFilter_Config[DebuffFilter_Player]["debuff_orientation"], "DebuffFilter_DebuffFrame");
	DebuffFilter_FrameOrientation(DebuffFilter_Config[DebuffFilter_Player]["buff_orientation"], "DebuffFilter_BuffFrame");
	DebuffFilter_TimeOrientation(DebuffFilter_Config[DebuffFilter_Player]["time_orientation"]);
end

function DebuffFilter_RegisterEvents(type)
	if (type == "debuffs") then
		DebuffFilter_DebuffFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
		DebuffFilter_DebuffFrame:RegisterEvent("UNIT_AURA");
	elseif (type == "buffs") then
		DebuffFilter_BuffFrame:RegisterEvent("PLAYER_AURAS_CHANGED");
	end
end

function DebuffFilter_UnregisterEvents(type)
	if (type == "debuffs") then
		DebuffFilter_DebuffFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
		DebuffFilter_DebuffFrame:UnregisterEvent("UNIT_AURA");
	elseif (type == "buffs") then
		DebuffFilter_BuffFrame:UnregisterEvent("PLAYER_AURAS_CHANGED");
	end
end

function DebuffFilter_OnMouseDown(arg1)
	if (arg1 == "LeftButton") and (IsShiftKeyDown()) then
		this:GetParent():StartMoving();
	elseif (arg1 == "RightButton") and (IsShiftKeyDown()) then
		local orientation, orientationkey, frame, name, time_orientation;
		
		if (this:GetParent():GetName() == "DebuffFilter_DebuffFrame") then
			orientation = DebuffFilter_Config[DebuffFilter_Player]["debuff_orientation"];
			orientationkey = "debuff_orientation";
			frame = "DebuffFilter_DebuffFrame";
			name = "debuff";
		else
			orientation = DebuffFilter_Config[DebuffFilter_Player]["buff_orientation"];
			orientationkey = "buff_orientation";
			frame = "DebuffFilter_BuffFrame";
			name = "buff";
		end

		if (orientation == "leftright") then
			DebuffFilter_Config[DebuffFilter_Player][orientationkey] = "topbottom";
			DebuffFilter_FrameOrientation("topbottom", frame);
			DebuffFilter_Print(name .. " frame orientation: top->bottom");
			time_orientation = "left";
		elseif (orientation == "topbottom") then
			DebuffFilter_Config[DebuffFilter_Player][orientationkey] = "rightleft";
			DebuffFilter_FrameOrientation("rightleft", frame);
			DebuffFilter_Print(name .. " frame orientation: right->left");
			time_orientation = "bottom";
		elseif (orientation == "rightleft") then
			DebuffFilter_Config[DebuffFilter_Player][orientationkey] = "bottomtop";
			DebuffFilter_FrameOrientation("bottomtop", frame);
			DebuffFilter_Print(name .. " frame orientation: bottom->top");
			time_orientation = "right";
		else
			DebuffFilter_Config[DebuffFilter_Player][orientationkey] = "leftright";
			DebuffFilter_FrameOrientation("leftright", frame);
			DebuffFilter_Print(name .. " frame orientation: left->right");
			time_orientation = "bottom";
		end

		if (frame == "DebuffFilter_BuffFrame") then
			DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] = time_orientation;
			DebuffFilter_TimeOrientation(time_orientation);
		end

	elseif (arg1 == "RightButton") and (IsControlKeyDown()) then
		local orientation = DebuffFilter_Config[DebuffFilter_Player]["buff_orientation"];
		local time_orientation = DebuffFilter_Config[DebuffFilter_Player]["time_orientation"];

		if (orientation == "leftright") or (orientation == "rightleft") then
			if (time_orientation == "bottom") then
				DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] = "top";
				DebuffFilter_TimeOrientation("top");
				DebuffFilter_Print("buff time orientation: top");
			else
				DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] = "bottom";
				DebuffFilter_TimeOrientation("bottom");
				DebuffFilter_Print("buff time orientation: bottom");
			end
		else
			if (time_orientation == "left") then
				DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] = "right";
				DebuffFilter_TimeOrientation("right");
				DebuffFilter_Print("buff time orientation: right");
			else
				DebuffFilter_Config[DebuffFilter_Player]["time_orientation"] = "left";
				DebuffFilter_TimeOrientation("left");
				DebuffFilter_Print("buff time orientation: left");
			end
		end
	end
end

function DebuffFilter_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		this:GetParent():StopMovingOrSizing();
	end
end

function DebuffFilter_OnLoad()
	DebuffFilter_Player = (UnitName("player").." - "..GetRealmName());
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function DebuffFilter_DebuffFrame_OnLoad()
	DebuffFilter_RegisterEvents("debuffs");
end

function DebuffFilter_BuffFrame_OnLoad()
	DebuffFilter_RegisterEvents("buffs");
end

local function DebuffFilter_DebuffFrame_Update(unit)
	local width = 0;
	for i = 1, 16, 1 do
		local name = "DebuffFilter_DebuffButton" .. i;
		local button = getglobal(name);
		local debufftexture, debuffapplications, debufftype = UnitDebuff(unit, i);
		local debufftext = getglobal(name .. "Count");

		if (debufftexture) then
			DebuffFilter_DebuffFrameCount:SetText(i);

			DebuffFilter_DebuffTooltip:SetOwner(UIParent, "ANCHOR_NONE");
			DebuffFilter_DebuffTooltip:ClearLines();
			DebuffFilter_DebuffTooltip:SetUnitDebuff(unit, i);

			if (DebuffFilter_Config[DebuffFilter_Player]["debuff_list"][DebuffFilter_DebuffTooltipTextLeft1:GetText()] == 1) then
				getglobal(name .. "Icon"):SetTexture(debufftexture);
				if (debufftype) then
					color = DebuffTypeColor[debufftype];
				else
					color = DebuffTypeColor["none"];
				end

				getglobal(name .. "Border"):SetVertexColor(color.r, color.g, color.b);
				button:SetWidth(30);
				button:SetHeight(30);
				button:Show();

				width = width + 1;

				if (DebuffFilter_Config[DebuffFilter_Player]["count"] == "yes") then
					DebuffFilter_DebuffFrameCount:Show();
				end
			else
				button:Hide();
				debufftext:SetText("");
				button:SetWidth(-2);
				button:SetHeight(-2);
			end
		else
			button:Hide();
			debufftext:SetText("");
			button:SetWidth(-2);
			button:SetHeight(-2);
		end

		if (DebuffFilter_Config[DebuffFilter_Player]["count"] == "yes") and (width == 0) then
			DebuffFilter_DebuffFrameCount:Hide();
		end
	end
end

local function DebuffFilter_BuffFrame_Update()
	local count = 0;
	local width = 0;

	for i = 0, 15, 1 do
		local name = "DebuffFilter_BuffButton" .. i;
		local button = getglobal(name);
		local buffindex, untilcancelled = GetPlayerBuff(i, "HELPFUL");
		local bufftext = getglobal(name .. "Count");
		local bufftime = getglobal(name .. "Duration");

		if (buffindex >= 0) then
			count = count + 1;
			DebuffFilter_BuffFrameCount:SetText(count);

			DebuffFilter_BuffTooltip:SetOwner(UIParent, "ANCHOR_NONE");
			DebuffFilter_BuffTooltip:ClearLines();
			DebuffFilter_BuffTooltip:SetPlayerBuff(buffindex);

			if (DebuffFilter_Config[DebuffFilter_Player]["buff_list"][DebuffFilter_BuffTooltipTextLeft1:GetText()] == 1) then
				getglobal(name .. "Icon"):SetTexture(GetPlayerBuffTexture(buffindex));

				local bufftimeleft = GetPlayerBuffTimeLeft(buffindex);
				if (untilcancelled ~= 1) then
					if (11 >= bufftimeleft) then
						bufftime:SetTextColor(1, 0, 0);
					else
						bufftime:SetTextColor(1, 0.82, 0);
					end

					bufftime:SetText(DebuffFilter_GetStrTime(floor(bufftimeleft)));
				else
					bufftime:SetText("");
				end

				button:SetWidth(30);
				button:SetHeight(30);
				button:Show();

				width = width + 1;

				if (DebuffFilter_Config[DebuffFilter_Player]["count"] == "yes") then
					DebuffFilter_BuffFrameCount:Show();
				end
			else
				button:Hide();
				bufftext:SetText("");
				bufftime:SetText("");
				button:SetWidth(-4);
				button:SetHeight(-4);
			end
		else
			button:Hide();
			bufftext:SetText("");
			bufftime:SetText("");
			button:SetWidth(-4);
			button:SetHeight(-4);
		end

		if (DebuffFilter_Config[DebuffFilter_Player]["count"] == "yes") and (width == 0) then
			DebuffFilter_BuffFrameCount:Hide();
		end
	end
end

function DebuffFilter_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		this:UnregisterEvent("VARIABLES_LOADED");
		DebuffFilter_Initialize();
	elseif (event == "PLAYER_ENTERING_WORLD") then
		this:UnregisterEvent("PLAYER_ENTERING_WORLD");
		DebuffFilter:SetScale(DebuffFilter_Config[DebuffFilter_Player]["scale"] * UIParent:GetScale());
	end
end

function DebuffFilter_DebuffFrame_OnEvent(event)
	if (event == "UNIT_AURA" and arg1 == DebuffFilter_Config[DebuffFilter_Player]["target"]) or (event == "PLAYER_TARGET_CHANGED") then
		DebuffFilter_DebuffFrame_Update(DebuffFilter_Config[DebuffFilter_Player]["target"]);
	end
end

function DebuffFilter_BuffFrame_OnEvent(event)
	DebuffFilter_BuffFrame_Update();
end

function DebuffFilter_DebuffButton_OnUpdate(elapsed)
	this.update = this.update + elapsed;
	if (this.update >= 1) then
		this.update = this.update - 1;
		local debufftexture, debuffapplications, debufftype = UnitDebuff(DebuffFilter_Config[DebuffFilter_Player]["target"], this:GetID());
		local debufftext = getglobal(this:GetName() .. "Count");
		if (debuffapplications > 1) then
			debufftext:SetText(debuffapplications);
		else
			debufftext:SetText("");
		end
	end
end

function DebuffFilter_BuffButton_OnUpdate(elapsed)
	this.update = this.update + elapsed;
	if (this.update >= 1) then
		this.update = this.update - 1;
		local buffindex, untilcancelled = GetPlayerBuff(this:GetID(), "HELPFUL");
		local buffapplications = GetPlayerBuffApplications(buffindex);
		local bufftimeleft = GetPlayerBuffTimeLeft(buffindex);
		local bufftext = getglobal(this:GetName() .. "Count");
		local bufftime = getglobal(this:GetName() .. "Duration");

		if (buffapplications > 1) then
			bufftext:SetText(buffapplications);
		else
			bufftext:SetText("");
		end

		if (untilcancelled == 1) then
			bufftime:SetText("");
			return;
		end

		if (11 >= bufftimeleft) then
			bufftime:SetTextColor(1, 0, 0);
		else
			bufftime:SetTextColor(1, 0.82, 0);
		end

		bufftime:SetText(DebuffFilter_GetStrTime(floor(bufftimeleft)));
	end
end

-- taken from ctmod
function DebuffFilter_GetStrTime(time)
	local min, sec;
	if ( time >= 60 ) then
		min = floor(time/60);
		sec = time - min*60;
	else
		sec = time;
		min = 0;
	end
	if ( sec <= 9 ) then sec = "0" .. sec; end
	if ( min <= 9 ) then min = "0" .. min; end
	return min .. ":" .. sec;
end

function DebuffFilter_FrameOrientation(orientation, frame)
	local name, start, num, relnum, xtemp, ytemp, countframe, point, relpoint, x, y;

	if (frame == "DebuffFilter_DebuffFrame") then
		name = "DebuffFilter_DebuffButton";
		start = getglobal(name .. 1);
		num, relnum = 0, 1;
		xtemp, ytemp = 2, 2;
	else
		name = "DebuffFilter_BuffButton";
		start = getglobal(name .. 0);
		num, relnum = 1, 2;
		xtemp, ytemp = 4, 4;
	end

	countframe = getglobal(frame .. "Count");

	start:ClearAllPoints();
	countframe:ClearAllPoints();

	if (orientation == "leftright") then
		point, relpoint, x, y = "LEFT", "RIGHT", xtemp, 0;
		start:SetPoint("LEFT", frame, "LEFT", 0, 0);
		countframe:SetPoint("RIGHT", frame, "LEFT", 0, 0);
	elseif (orientation == "topbottom") then
		point, relpoint, x, y = "TOP", "BOTTOM", 0, ytemp*-1;
		start:SetPoint("TOP", frame, "TOP", 0, 0);
		countframe:SetPoint("BOTTOM", frame, "TOP", 0, 8);
	elseif (orientation == "rightleft") then
		point, relpoint, x, y = "RIGHT", "LEFT", xtemp*-1, 0;
		start:SetPoint("RIGHT", frame, "RIGHT", 0, 0);
		countframe:SetPoint("LEFT", frame, "RIGHT", 0, 0);
	elseif (orientation == "bottomtop") then
		point, relpoint, x, y = "BOTTOM", "TOP", 0, ytemp;
		start:SetPoint("BOTTOM", frame, "BOTTOM", 0, 0);
		countframe:SetPoint("TOP", frame, "BOTTOM", 0, -8);
	end

	for i = 2, 16, 1 do
		local button, relbutton;

		button = getglobal(name .. i-num);
		relbutton = name .. (i-relnum);
		
		button:ClearAllPoints();
		button:SetPoint(point, relbutton, relpoint, x, y);
	end
end

function DebuffFilter_TimeOrientation(orientation)
	for i = 0, 15, 1 do
		local name = "DebuffFilter_BuffButton" .. i;
		local bufftime = getglobal(name .. "Duration");

		bufftime:ClearAllPoints();

		if (orientation == "left") then
			bufftime:SetPoint("RIGHT", name, "LEFT", -4, 0);
		elseif (orientation == "right") then
			bufftime:SetPoint("LEFT", name, "RIGHT", 4, 0);
		elseif (orientation == "top") then
			bufftime:SetPoint("BOTTOM", name, "TOP", 0, 2);
		elseif (orientation == "bottom") then
			bufftime:SetPoint("TOP", name, "BOTTOM", 0, 0);
		end
	end
end

function DebuffFilter_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Debuff Filter|r: " .. msg);
end

function DebuffFilter_command(arg1)
	local i, j, cmd, param = string.find(arg1, "^([^ ]+) (.+)$");
	if (not cmd) then
		cmd = arg1;
	end

	if (not param) then
		param = "";
	end

	cmd = string.lower(cmd);

	if (cmd == "debuffs") then
		if (DebuffFilter_Config[DebuffFilter_Player]["debuffs"] == "yes") then
			DebuffFilter_Config[DebuffFilter_Player]["debuffs"] = "no";
			DebuffFilter_DebuffFrame:Hide();
			DebuffFilter_UnregisterEvents("debuffs");
			DebuffFilter_Print("debuff filtering disabled.");
		else
			DebuffFilter_Config[DebuffFilter_Player]["debuffs"] = "yes";
			DebuffFilter_RegisterEvents("debuffs");
			DebuffFilter_DebuffFrame_Update(DebuffFilter_Config[DebuffFilter_Player]["target"]);
			DebuffFilter_DebuffFrame:Show();
			DebuffFilter_Print("debuff filtering enabled.");
		end
	elseif (cmd == "buffs") then
		if (DebuffFilter_Config[DebuffFilter_Player]["buffs"] == "yes") then
			DebuffFilter_Config[DebuffFilter_Player]["buffs"] = "no";
			DebuffFilter_BuffFrame:Hide();
			DebuffFilter_UnregisterEvents("buffs");
			DebuffFilter_Print("buff filtering disabled.");
		else
			DebuffFilter_Config[DebuffFilter_Player]["buffs"] = "yes";
			DebuffFilter_RegisterEvents("buffs");
			DebuffFilter_BuffFrame_Update();
			DebuffFilter_BuffFrame:Show();
			DebuffFilter_Print("buff filtering enabled.");
		end
	elseif (cmd == "scale") then
		if tonumber(param) and (tonumber(param) >= 0.5) and (tonumber(param) <=3.0) then
			DebuffFilter_Config[DebuffFilter_Player]["scale"] = tonumber(param);
			DebuffFilter:SetScale(DebuffFilter_Config[DebuffFilter_Player]["scale"] * UIParent:GetScale());
			DebuffFilter_DebuffFrame:ClearAllPoints();
			DebuffFilter_DebuffFrame:SetPoint("CENTER", "UIParent", "CENTER", -20, 0);
			DebuffFilter_BuffFrame:ClearAllPoints();
			DebuffFilter_BuffFrame:SetPoint("LEFT", "DebuffFilter_DebuffFrame", "RIGHT", 20, 0);
			DebuffFilter_Print("scale set to " .. DebuffFilter_Config[DebuffFilter_Player]["scale"] .. ".");
		else
			DebuffFilter_Print("please choose a number between 0.5 and 3.  Current scale: " .. DebuffFilter_Config[DebuffFilter_Player]["scale"] .. ".");
		end
	elseif (cmd == "backdrop") then
		if (DebuffFilter_Config[DebuffFilter_Player]["debuffs"] == "yes") or (DebuffFilter_Config[DebuffFilter_Player]["buffs"] == "yes") then
			if (DebuffFilter_DebuffFrameBackdrop:IsVisible()) or (DebuffFilter_BuffFrameBackdrop:IsVisible()) then
				DebuffFilter_DebuffFrameBackdrop:Hide();
				DebuffFilter_BuffFrameBackdrop:Hide();
				DebuffFilter_Print("now hiding backdrop.");
			else
				DebuffFilter_DebuffFrameBackdrop:Show();
				DebuffFilter_BuffFrameBackdrop:Show();
				DebuffFilter_Print("now showing backdrop.");
			end
		else
			DebuffFilter_Print("unable to display backdrop, both frames disabled.");
		end
	elseif (cmd == "target") then
		DebuffFilter_Config[DebuffFilter_Player]["target"] = "target";
		DebuffFilter_DebuffFrame_Update(DebuffFilter_Config[DebuffFilter_Player]["target"]);
		DebuffFilter_Print("now monitoring debuffs on your current target.");
	elseif (cmd == "targettarget") then
		DebuffFilter_Config[DebuffFilter_Player]["target"] = "targettarget";
		DebuffFilter_DebuffFrame_Update(DebuffFilter_Config[DebuffFilter_Player]["target"]);
		DebuffFilter_Print("now monitoring debuffs on your target's target.");
	elseif (cmd == "count") then
		if (DebuffFilter_Config[DebuffFilter_Player]["count"] == "yes") then
			DebuffFilter_Config[DebuffFilter_Player]["count"] = "no";
			DebuffFilter_BuffFrameCount:Hide();
			DebuffFilter_DebuffFrameCount:Hide();
			DebuffFilter_Print("no longer showing debuff/buff count.");
		else
			DebuffFilter_Config[DebuffFilter_Player]["count"] = "yes";
			DebuffFilter_Print("now showing debuff/buff count.");
		end
	elseif (cmd == "tooltips") then
		if (DebuffFilter_Config[DebuffFilter_Player]["tooltips"] == "yes") then
			DebuffFilter_Config[DebuffFilter_Player]["tooltips"] = "no";
			DebuffFilter_Print("tooltips disabled.");
		else
			DebuffFilter_Config[DebuffFilter_Player]["tooltips"] = "yes";
			DebuffFilter_Print("tooltips enabled.");
		end
	elseif (cmd == "add") and not (param == "") then
		DebuffFilter_Config[DebuffFilter_Player]["debuff_list"][param] = 1;
		DebuffFilter_DebuffFrame_Update(DebuffFilter_Config[DebuffFilter_Player]["target"]);
		DebuffFilter_Print("Now monitoring for debuff: \"" .. param .. "\"");
	elseif (cmd == "del") and not (param == "") then
		if (DebuffFilter_Config[DebuffFilter_Player]["debuff_list"][param]) then
			DebuffFilter_Config[DebuffFilter_Player]["debuff_list"][param] = nil;
			DebuffFilter_DebuffFrame_Update(DebuffFilter_Config[DebuffFilter_Player]["target"]);
			DebuffFilter_Print("no longer monitoring for debuff: \"" .. param .. "\"");
		else
			DebuffFilter_Print("unable to find debuff: \"" .. param .. "\"");
		end
	elseif (cmd == "addb") and not (param == "") then
		DebuffFilter_Config[DebuffFilter_Player]["buff_list"][param] = 1;
		DebuffFilter_BuffFrame_Update();
		DebuffFilter_Print("Now monitoring for buff: \"" .. param .. "\"");
	elseif (cmd == "delb") and not (param == "") then
		if (DebuffFilter_Config[DebuffFilter_Player]["buff_list"][param]) then
			DebuffFilter_Config[DebuffFilter_Player]["buff_list"][param] = nil;
			DebuffFilter_BuffFrame_Update();
			DebuffFilter_Print("no longer monitoring for buff: \"" .. param .. "\"");
		else
			DebuffFilter_Print("unable to find buff: \"" .. param .. "\"");
		end
	elseif (cmd == "list") then
		DebuffFilter_Print("currently monitored debuffs:");
		for i in DebuffFilter_Config[DebuffFilter_Player]["debuff_list"] do
			DEFAULT_CHAT_FRAME:AddMessage("\"" .. i .. "\"");
		end
	elseif (cmd == "listb") then
		DebuffFilter_Print("currently monitored buffs:");
		for i in DebuffFilter_Config[DebuffFilter_Player]["buff_list"] do
			DEFAULT_CHAT_FRAME:AddMessage("\"" .. i .. "\"");
		end
	elseif (cmd == "status") then
		DebuffFilter_Print("current settings:");
		DebuffFilter_Print("current scale: " .. DebuffFilter_Config[DebuffFilter_Player]["scale"]);
		DebuffFilter_Print("current debuff orientation: " .. DebuffFilter_Config[DebuffFilter_Player]["debuff_orientation"]);
		DebuffFilter_Print("current buff orientation: " .. DebuffFilter_Config[DebuffFilter_Player]["buff_orientation"]);
		DebuffFilter_Print("current time orientation: " .. DebuffFilter_Config[DebuffFilter_Player]["time_orientation"]);
		DebuffFilter_Print("current target: " .. DebuffFilter_Config[DebuffFilter_Player]["target"]);
		DebuffFilter_Print("show debuff/buff count: " .. DebuffFilter_Config[DebuffFilter_Player]["count"]);
		DebuffFilter_Print("show tooltips: " .. DebuffFilter_Config[DebuffFilter_Player]["tooltips"]);
		DebuffFilter_Print("debuff filtering: " .. DebuffFilter_Config[DebuffFilter_Player]["debuffs"]);
		DebuffFilter_Print("buff filtering: " .. DebuffFilter_Config[DebuffFilter_Player]["buffs"]);
	else
		DEFAULT_CHAT_FRAME:AddMessage("Debuff Filter commands:");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00debuffs|r: toggle debuff filtering on and off.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00buffs|r: toggle buff filtering on and off.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00scale [0.5-3.0]|r: scale the size of the debuff icons.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00backdrop|r: toggle a backdrop to assist in moving the debuff/buff frames.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00target|r: monitor your current target's debuffs.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00targettarget|r: monitor the current debuffs on your target's target.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00count|r: toggle a total debuff/buff count display.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00tooltips|r: toggle tooltips on and off.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00add [debuff]|r: add a new debuff to monitor.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00del [debuff]|r: remove a currently monitored debuff.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00addb [buff]|r: add a new buff to monitor.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00delb [buff]|r: remove a currently monitored buff.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00list|r: view the currently monitored debuff list.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00listb|r: view the currently monitored buff list.");
		DEFAULT_CHAT_FRAME:AddMessage("/dfilter |cff00ff00status|r: display current settings.");
		DEFAULT_CHAT_FRAME:AddMessage("To move the frames, shift+left click and drag a backdrop or one of the monitored debuffs/buffs.");
		DEFAULT_CHAT_FRAME:AddMessage("To change the frame or time orientation, shift+right click or ctrl+right click, respectively.");
	end
end